﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=3.82
@EndOfDesignText@
'Class module
Sub Class_Globals
Private closebtn As Button
Private Hue, Sat, Lum As Float
Private  selectedcolor As Int 
Private Clbl(3), Hlbl(3), colorselectlbl As Label
Private mymodule As Object
Private colorpnl, basepnl, palette, lumpnl, lumcursor, pltcursor As Panel
Private myname As String
Private myview As View
Private PH As Phone
End Sub

'Initializes the object
'Example:
'mycol.Initialize(Activity, "main", "mycol")
Public Sub Initialize(Parent As Activity, Module As Object, Eventname As String)
mymodule = Module
myname = Eventname
Dim CF As Double =  Sqrt((100%y * 100%y + 100%x * 100%x)/(Power(430 * Density,2) + Power(800 * Density,2))) 

colorpnl.Initialize("colorpnl")
colorpnl.color = Colors.DarkGray
palette.Initialize("palette")
pltcursor.Initialize("")
pltcursor.SetBackgroundImage(LoadBitmap(File.DirAssets,"cursor.png"))
palette.SetBackgroundImage(LoadBitmap(File.DirAssets,"colorpalette.bmp"))
lumpnl.Initialize("lumpnl")
lumcursor.Initialize("")
lumcursor.SetBackgroundImage(LoadBitmap(File.DirAssets,"cursor.png"))
basepnl.Initialize("")
basepnl.color = Colors.white
colorselectlbl.Initialize("colorselectlbl")
colorselectlbl.text = "OK"
colorselectlbl.Typeface = Typeface.DEFAULT_BOLD
colorselectlbl.Gravity = Bit.Or(Gravity.CENTER_VERTICAL, Gravity.CENTER_HORIZONTAL)
colorselectlbl.textsize = 22*CF
closebtn.Initialize("closebtn")
closebtn.Text = "close"
closebtn.TextSize = 24 * CF
For i = 0 To 2
	Clbl(i).Initialize("")
	Clbl(i).TextColor = Colors.White
	Clbl(i).Gravity = Gravity.RIGHT
	Clbl(i).textsize = 20*CF
	Hlbl(i).Initialize("")
	Hlbl(i).TextColor = Colors.White
	Hlbl(i).Gravity = Gravity.left
	Hlbl(i).textsize = 20*CF
Next
Hlbl(0).Text = "R:"
Hlbl(1).Text = "G:"
Hlbl(2).Text = "B:"

If Parent.Height > Parent.Width Then
	Parent.AddView(colorpnl,0,0,100%x,35%y)
	colorpnl.AddView(palette, 1.125%x,2%y,50%x,30%y)
	palette.AddView(pltcursor, 0,0,3.2%x,1.8%y)
	colorpnl.AddView(lumpnl, 55%x,2%y,6%x,30%y)
	lumpnl.AddView(lumcursor,lumpnl.Width/2 - 0.9%y,lumpnl.Height/2,1.8%y,1.8%y)
	colorpnl.AddView(basepnl, 70%x,2%y,20%x,8%y)
	basepnl.AddView(colorselectlbl,1.05%x, 0.6%y,basepnl.Width - 2.1%x,basepnl.Height - 1.2%y)
	colorpnl.AddView(closebtn, 70%x,24%y,20%x,8%y)
	For i = 0 To 2
		colorpnl.AddView(Clbl(i),75%x,13%y +3%y*i ,10%x,5%y)
		colorpnl.AddView(Hlbl(i),73%x,13%y +3%y*i ,5%x,5%y)
	Next
Else 
	Parent.AddView(colorpnl,0,0,100%x,100%y)
	colorpnl.AddView(palette, 2%x,3.56%y,50%x,88.89%y)
	palette.AddView(pltcursor, 0,0,2.65%x,4.7%y)
	colorpnl.AddView(lumpnl, 58.82%x,3.56%y,8.09%x,88.89%y)
	lumpnl.AddView(lumcursor,lumpnl.Width/2 - 1.32%x,lumpnl.Height/2,2.65%x,2.65%x)
	colorpnl.AddView(basepnl, 75%x,3.56%y,16.44%x,28.9%y)
	basepnl.AddView(colorselectlbl, 0.88%x,1.54%y,14.7%x,25.74%y)
	colorpnl.AddView(closebtn, 75%x,78%y,16.18%x,14.7%y)
	For i = 0 To 2
		colorpnl.AddView(Clbl(i),80%x,40%y +9%y*i ,7.35%x,13%y)
		colorpnl.AddView(Hlbl(i),77%x,40%y +9%y*i ,2.94%x,13%y)
	Next
End If
Dim dr As GradientDrawable
dr.Initialize("TOP_BOTTOM" ,Array As Int(Colors.white,Colors.rgb(60,60,60)))
dr.CornerRadius = 1%x
closebtn.Background = dr
colorpnl.Visible = False
colorpnl.Tag = -1
End Sub

'Returns the base panel
Public Sub AsView As View
Return colorpnl
End Sub

'Shows the palette for color selection.
'The color is returned after "OK" button press to 
'Sub [object name] _Result( col As Int, res() As Int) in the calling module.
'res() contains the 4 parts of the color: Alfa,R, G, B.
'The Palette will show the default color when displayed.
'AsView.Tag = -1 , to be used in the Result sub.
Public Sub GetColor
myview = Null
selectedcolor = Colors.RGB(50,50,255)
Common
End Sub

'Shows the palette for color selection.
'The color is returned after "OK" button press to 
'Sub [object name] _Result( col As Int, res() As Int) in the calling module.
'res() contains the 4 parts of the color: Alfa,R, G, B.
'The Palette will show the default color when displayed.
'JobId is attached to AsView.Tag, to be used in the Result sub.
Public Sub GetColor1(JobId As Int)
myview = Null
colorpnl.Tag = JobId
selectedcolor = Colors.RGB(50,50,255)
Common
End Sub

'Shows the palette for color selection.
'The color is returned after "OK" button press to 
'Sub [object name] _Result( col As Int, res() As Int) in the calling module.
'res() contains the 4 parts of the color: Alfa,R, G, B.
'The Palette will show the supplied color when displayed.
'JobId is attached to AsView.Tag, to be used in the Result sub.
Public Sub GetColor2(color As Int,JobId As Int)
myview = Null
colorpnl.Tag = JobId
selectedcolor = color
Common
End Sub

'Shows the palette for color selection.
'Colors the ViewName View with the selected color.
'The color is returned after "OK" button press to 
'Sub [object name] _Result( col As Int, res() As Int) in the calling module.
'res() contains the 4 parts of the color: Alfa,R, G, B.
'The Palette will show the view's color when displayed.
'ViewName is attached to AsView.Tag, to be used in the Result sub.
Public Sub ChangeColor(ViewName As View)
myview = ViewName
colorpnl.Tag = ViewName
selectedcolor = ColorPick(ViewName)
ViewName.color = selectedcolor
Common
End Sub

'Shows the palette for color selection.
'Colors the ViewName View with the selected color.
'The color is returned after "OK" button press to 
'Sub [object name] _Result( col As Int, res() As Int) in the calling module.
'res() contains the 4 parts of the color: Alfa,R, G, B.
'The Palette will show the supplied color when displayed.
'ViewName is attached to AsView.Tag, to be used in the Result sub.
Public Sub ChangeColor2(ViewName As View, color As Int)
myview = ViewName
colorpnl.Tag = ViewName
selectedcolor = color
ViewName.color = selectedcolor
Common
End Sub

'Returns the color of the view
Public Sub ColorPick(ViewName As View) As Int
Dim cnvs As Canvas
cnvs.Initialize(ViewName)
Return(cnvs.Bitmap.GetPixel(3dip,3dip))
End Sub

Private Sub Common
FreezeOrientation
COLORtoHSL(selectedcolor)
drawlum
colorselectlbl.color = selectedcolor
colorselectlbl.textcolor = selectedcolor
colorpnl.Visible = True
colorpnl.BringToFront
ParseColor2(selectedcolor)
colorselectlbl.textcolor = Colors.RGB(255-Clbl(0).text,255-Clbl(1).text,255-Clbl(2).text)
End Sub

'Returns a Int array of the 4 parameters of a color :
'Alfa, R ,G, B
Public Sub ParseColor(clr As Int) As Int()
Dim res(4) As Int
res(0) = Bit.UnsignedShiftRight(Bit.And(clr, 0xff000000), 24) ' alfa
res(1) = Bit.UnsignedShiftRight(Bit.And(clr, 0xff0000), 16)   ' R
res(2) = Bit.UnsignedShiftRight(Bit.And(clr, 0xff00), 8)      ' G
res(3) = Bit.And(clr, 0xff)  ' B
Return res
End Sub

Private Sub ParseColor2(clr As Int) 
Clbl(0).text = Bit.UnsignedShiftRight(Bit.And(clr, 0xff0000), 16)   ' R
Clbl(1).text = Bit.UnsignedShiftRight(Bit.And(clr, 0xff00), 8)      ' G
Clbl(2).text = Bit.And(clr, 0xff)  ' B
End Sub



Private Sub colorselectlbl_click
If myview.IsInitialized Then myview.color = selectedcolor
colorpnl.Visible = False
ReleaseOrientation
CallSub3(mymodule, myname & "_Result", selectedcolor, ParseColor(selectedcolor))
End Sub

Private Sub drawlum
Dim col As Long
Dim Canvas As Canvas
Dim k As Float
Canvas.Initialize(lumpnl)
For i = 0 To lumpnl.Height - 1
	k = i
	col = HSLToRGB(Hue,Sat, 240*(1-k / lumpnl.Height))
	Canvas.DrawLine(0,i,lumpnl.Width,i,col,1)
Next 
End Sub

Private Sub palette_Touch (Action As Int, X As Float, Y As Float)
If X < 0 Then X = 0
If X > palette.Width Then X = palette.Width - pltcursor.Width/2
If Y < 0 Then Y = 0
If Y > palette.Height Then Y = palette.Height - pltcursor.height/2

If 100%y > 100%x Then
	pltcursor.Left = X -  0.9%x
	pltcursor.Top  = Y - 0.9%x 
Else
	pltcursor.Left = X -  1.3%x 
	pltcursor.Top  = Y - 1.3%x 
End If
Hue = X * 240 / palette.Width
Sat = (palette.height - Y) * 240/palette.Height
Lum = 120
lumcursor.Top = lumpnl.Height/2 - lumcursor.Height/2
selectedcolor = HSLToRGB(Hue,Sat,Lum)
drawlum
colorselectlbl.color = selectedcolor
ParseColor2(selectedcolor)
colorselectlbl.textcolor = Colors.RGB(255-Clbl(0).text,255-Clbl(1).text,255-Clbl(2).text)
End Sub

Private Sub lumpnl_Touch (Action As Int, X As Float, Y As Float)
If Y < 0 Then Y = 0
If Y > lumpnl.Height Then Y = lumpnl.Height

Lum = (lumpnl.Height - Y)*240/lumpnl.Height
lumcursor.Top = Y - lumcursor.Height/2
selectedcolor = HSLToRGB(Hue,Sat,Lum)
colorselectlbl.color = selectedcolor
ParseColor2(selectedcolor)
colorselectlbl.textcolor = Colors.RGB(255-Clbl(0).text,255-Clbl(1).text,255-Clbl(2).text)
End Sub

Private Sub closebtn_Click
colorpnl.Visible = False
End Sub

'Returns the RGB color of  Lum,Sat and Hue parameters.
Public Sub HSLToRGB(H As Float,S As Float ,L As Float) As Int
Dim  k As Int
Dim H0 ,M1 ,M0 , D As Float
Dim col As Int
			
If H = 240 Then  H = 0  ' 240 identical To 0
H0 =  H / 40
If L < 120 Then
		M1=255*L*(1+S/240)/240
		M0=255*L*(1-S/240)/240
Else
		M1=255*(L/240*(1-S/240)+S/240)
		M0=255*(L/240*(1+S/240)-S/240)
End If
		
D = M1 - M0 
k = H0
Select k
	Case 0
		col = Colors.Rgb(M1 ,M0+H0*D,M0)
	Case 1
		col = Colors.Rgb(M0+(2-H0)*D,M1,M0)
	Case 2
		col = Colors.Rgb(M0,M1,M0+(H0-2)*D) 
	Case 3
		col = Colors.Rgb(M0,M0+(4-H0)*D,M1) 
	Case 4
		col = Colors.Rgb(M0+(H0-4)*D,M0,M1)
	Case 5
		col = Colors.Rgb(M1,M0,M0+(6-H0)*D)
End Select
Return col
End Sub

'Returns a Int array with Lum,Sat,Hue (by that order) from a color.
Public Sub COLORtoHSL(clr As Int) As Int()
Dim R,G ,B As Float
Dim maxcolor,mincolor, D, P As Float
Dim res(4) As Int

res(0) = Bit.UnsignedShiftRight(Bit.And(clr, 0xff000000), 24) ' alfa
res(1) = Bit.UnsignedShiftRight(Bit.And(clr, 0xff0000), 16)   ' R
res(2) = Bit.UnsignedShiftRight(Bit.And(clr, 0xff00), 8)      ' G
res(3) = Bit.And(clr, 0xff)                                   ' B

R = res(1)/255   ' between 0 to 1
G = res(2)/255
B = res(3)/255
maxcolor = Max(Max(R,G),B)
mincolor = Min(Min(R,G),B)
D = maxcolor - mincolor
P = maxcolor + mincolor
Lum = P/2
If maxcolor = mincolor Or Lum = 0  Then 
	Sat = 0
Else
	If Lum < 0.5 Then
		Sat = D/P
	Else
		Sat = D/(2.0 - P)
	End If
End If
If maxcolor = mincolor Then
	Hue = 0
Else
	Select maxcolor
		Case R 
			Hue = ((G-B)/D)/6 
		Case G
			Hue = (2 + (B-R)/D)/6
		Case B
			Hue = (4 + (R-G)/D)/6
	End Select
	If Hue < 0 Then Hue = Hue + 1
End If
lumcursor.Top = lumpnl.Height*(1 - Lum)  - lumcursor.Height/2
pltcursor.Left = Hue * palette.Width - pltcursor.Width/2
pltcursor.Top =  palette.Height * (1 -  Sat) - pltcursor.Height/2
Lum = Lum * 240 
Sat = Sat * 240 
Hue = Hue * 240 
res(0) = Lum
res(1) = Sat
res(2) = Hue
Return res
End Sub

Private Sub colorpnl_click
End Sub
Private Sub colorpnl_longclick
End Sub

Sub FreezeOrientation
	Dim k, m, n As Int
	k = GetOrientation
	If 100%x > 100%y Then m = 0 Else m = 1
	n = k + m
	If (n) Mod(2) = 0 Then 
		 PH.SetScreenOrientation(k)
	Else
		PH.SetScreenOrientation(1-k Mod(2))
	End If
End Sub

Sub GetOrientation As Int
  Dim r As Reflector
  r.Target = r.GetContext
  r.Target = r.RunMethod2("getSystemService", "window", "java.lang.String")
  r.Target = r.RunMethod("getDefaultDisplay")
  Return r.RunMethod("getRotation")
End Sub

Sub ReleaseOrientation
    PH.SetScreenOrientation(-1)
End Sub

